import java.awt.Color;
import java.util.Vector;

public class CVPacketList {

	public CVPacket[] cvpaPackets;
	public double dMeanSize;
	public double dStdDevSize;
	public double dVarianceSize;
	public double dVarianceTime = 0;
	public double dTimeElapsed;
	public double dBytePerSec;
	public double dStartTime;
	public double dFinishTime;
	public double dTotalTime;
	public double dMeanTimeBetweenPackets;
	public double dStdDevTimeBetweenPackets;
	public int iSmallestPacket;
	public int iLargestPacket;
	public String strThisIPAddr;
	public Color cSelectedColor;

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public CVPacketList(CVPacket[] cvpaSearchList, boolean bSender, String strIPAddr) {

		Vector vecPacketList = new Vector();
		CVPacket cvCurPacket;
		int i;

		strThisIPAddr = strIPAddr;
		for(i=0;i<cvpaSearchList.length;i++) {
			cvCurPacket = cvpaSearchList[i];
			if(bSender) {
				if(strIPAddr.equals(cvCurPacket.strSenderIP))
						vecPacketList.addElement(cvCurPacket);
			} else if(strIPAddr.equals(cvCurPacket.strDestinationIP))
						vecPacketList.addElement(cvCurPacket);
		}//end for
//		cvpaPackets = new CVPacket[vecPacketList.size()];
//		for(i=0;i<vecPacketList.size();i++) {
//			cvpaPackets[i] = (CVPacket)vecPacketList.elementAt(i);
//		}
	init(vecPacketList);

	}//end CVIPAddr(Vector)

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public void init(Vector vecPacketList) {
		CVPacket cvCurPacket,cvFirstPacket;
		int iTotalSize=0;
		int i;

	//	sort(vecPacketList);

		cvFirstPacket = (CVPacket)vecPacketList.elementAt(0);
		cvCurPacket = (CVPacket)vecPacketList.elementAt(vecPacketList.size()-1);
		dTimeElapsed = cvCurPacket.ptTime.totalTime-cvFirstPacket.ptTime.totalTime;
		iSmallestPacket = cvFirstPacket.iPacketSize;
		iLargestPacket = iSmallestPacket;
		dStartTime = cvFirstPacket.ptTime.totalTime;
		System.out.println("Getting metrics");

		for(i=0;i<vecPacketList.size();i++) {
			cvCurPacket = (CVPacket)vecPacketList.elementAt(i);
			iTotalSize +=  cvCurPacket.iPacketSize;
			if(cvCurPacket.iPacketSize>iLargestPacket)
				iLargestPacket = cvCurPacket.iPacketSize;
			if(cvCurPacket.iPacketSize<iSmallestPacket)
				iSmallestPacket = cvCurPacket.iPacketSize;

		}//end for
System.out.println("Calculating stats");
		dMeanSize = iTotalSize/vecPacketList.size();
		dVarianceSize = 0;
		for(i=0;i<vecPacketList.size();i++) {
			cvCurPacket = (CVPacket)vecPacketList.elementAt(i);
			dVarianceSize = dVarianceSize +
						(dMeanSize-cvCurPacket.iPacketSize) * (dMeanSize-cvCurPacket.iPacketSize);
		}//end for
		dVarianceSize = dVarianceSize/vecPacketList.size();
		dStdDevSize = Math.sqrt(dVarianceSize);
		dBytePerSec = iTotalSize/dTimeElapsed;
		cvpaPackets = new CVPacket[vecPacketList.size()];
		for(i=0;i<vecPacketList.size();i++) {
			cvpaPackets[i] = (CVPacket)vecPacketList.elementAt(i);
			cvpaPackets[i].ptTime.totalTime -= dStartTime;
		}//end for
		dFinishTime = cvpaPackets[cvpaPackets.length-1].ptTime.totalTime;
		dTotalTime = dFinishTime;
		double dTimeAfterLastPacket;
		dMeanTimeBetweenPackets = dTotalTime/cvpaPackets.length;
		for(i=1;i<cvpaPackets.length;i++) {
			dTimeAfterLastPacket = cvpaPackets[i].ptTime.totalTime -
								   cvpaPackets[i-1].ptTime.totalTime;
			dVarianceTime = dVarianceTime + (dMeanTimeBetweenPackets-dTimeAfterLastPacket) *
											(dMeanTimeBetweenPackets-dTimeAfterLastPacket);
		}//end for
		dVarianceTime = (double)dVarianceTime/cvpaPackets.length;
		dStdDevTimeBetweenPackets = Math.sqrt(dVarianceTime);
	}//end init

	public String getStats() {
		StringBuffer strbReturn;

		strbReturn = new StringBuffer();
		strbReturn.append("Total Packets:"+cvpaPackets.length+"\n");
		strbReturn.append("Mean Size:"+dMeanSize+"\n");
		strbReturn.append("Size Std Dev:"+dStdDevSize+"\n");
		strbReturn.append("Largest Packet:"+iLargestPacket+"\n");
		strbReturn.append("Smallest Packet:"+iSmallestPacket+"\n");
		strbReturn.append("Mean Time Between Packets:"+dMeanTimeBetweenPackets+"\n");
		strbReturn.append("Time Between Packets Std Dev:"+dStdDevTimeBetweenPackets+"\n");
		strbReturn.append("Bytes per Second:"+dBytePerSec+"\n");
		strbReturn.append("Total time:"+dTotalTime+"\n");

		return strbReturn.toString();
	}//end getStats

	/**
	 ***********************************************************************
	 *
	 * quicksort
	 */
	// sorts the whole thing
	private void sort(Vector array)
	{
		sort(array, 0, array.size() - 1);
	}

	/**
	 ***********************************************************************
	 *
	 *
	 */
	// sorts partition
	private void sort(Vector array, int start, int end)
	{
		int p;

		if (end > start)
	    {
		    p = partition(array, start, end);
			sort(array, start, p-1);
			sort(array, p+1, end);
		}
	}

	/**
	 ***********************************************************************
	 *
	 *
	 */
	private int partition(Vector array, int start, int end)
	{
		int left, right;
		CVPacket partitionElement;

		partitionElement = (CVPacket)array.elementAt(end);

	    left = start - 1;
	    right = end;

		while(true)
	    {
		    while (partitionElement.compare((CVPacket)array.elementAt(++left)) == 1)
			{
		        if (left == end) break;
	        }

			while (partitionElement.compare((CVPacket)array.elementAt(--right)) == -1)
	        {
	            if (right == start) break;
	        }

			if (left >= right) break;

			swap(array, left, right);
		}

		swap(array, left, end);
	    return left;
	}

	/**
	 ***********************************************************************
	 *
	 *
	 */
	private void swap(Vector array, int i, int j)
	{
		Object temp;

		temp = array.elementAt(i);
		array.setElementAt(array.elementAt(j), i);
		array.setElementAt(temp, j);
	}

	/**
	 ***********************************************************************
	 *
	 *
	 *
	public int getTotalNum() {
		return cvpaPackets.length;
	}//end getTotalNum

	/**
	 ***********************************************************************
	 *
	 *
	 *
	public String getIP() {
		return strThisIPAddr;
	}//end getIP

	/**
	 ***********************************************************************
	 *
	 *
	 *
	public CVPacket[] getSentList() {
		return cvpaPackets;
	}//end getSentList()

	/**
	 ***********************************************************************
	 *
	 *
	 *
	public double getMeanSize() {
		return dMeanSize;
	}//end getMeanSize()

	/**
	 ***********************************************************************
	 *
	 *
	 *
	public double getSizeStdDev() {
		return dStdDevSize;
	}//end getSizeStdDev

	/**
	 ***********************************************************************
	 *
	 *
	 *
	public int getSmallPacket() {
		return iSmallestPacket;
	}//end getLargePacket

	/**
	 ***********************************************************************
	 *
	 *
	 *
	public int getLargePacket() {
		return iLargestPacket;
	}//end getLargePacket */
}//end CVIPAddr